package trees;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.*;
import javax.swing.tree.*;
import java.awt.*;
import javax.imageio.*;

public class Window extends javax.swing.JFrame {
    /** Creates new form Window */
    public Window() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jButton1 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jButton1.setText("jButton1");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jList1);

        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Monospaced", 1, 24)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane3.setViewportView(jTextArea1);

        jLabel1.setText("jLabel1");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addComponent(jButton1)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 265, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(30, 30, 30)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 233, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(28, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private String fmt (long n)
    {
        String s = Long.toString (n);
        String t = "";
        int cnt = 0;
        for (int i = s.length()-1; i >= 0 ; i--)
        {
           t = s.charAt(i) + t;
           cnt ++;
           if (cnt % 3 == 0)
               t = " " + t;
        }
        return t;
    }

    DefaultTreeModel model;

    private void showDir
            (DefaultMutableTreeNode above,
             File dir)
    {
       File [] list = dir.listFiles();

       for (File f : list )
       {
          if (f.isDirectory())
          {
             DefaultMutableTreeNode node =
                new DefaultMutableTreeNode 
                     (new FileInfo (f));

             above.add (node);

             showDir (node, f);
          }
       }

    }

    private File visibleDir;

    private void showFiles (File dir)
    {
        visibleDir = dir;

        DefaultListModel m = new DefaultListModel();
        jList1.setModel (m);

        for (File f : dir.listFiles())
            if (f.isFile())
               m.addElement(new FileInfo (f));
    }


    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
       // import javax.swing.tree.*;
       DefaultMutableTreeNode top =
          new DefaultMutableTreeNode ("Abc");

       model = new DefaultTreeModel (top);

       jTree1.setModel (model);

       /*
       for (int inx = 0; inx < list.length; inx++)
       {
           File f = list [inx];
       }
       */

       // import java.io.*;
       File dir = new File ("C:\\work");
       String t = dir.getAbsolutePath() + ", " +
                  fmt (dir.getUsableSpace()) + " of " +
                  fmt (dir.getTotalSpace());
       top.setUserObject (new FileInfo (dir));

       showDir (top, dir);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
       TreePath path = evt.getPath();
       Object last = path.getLastPathComponent();
       if (last instanceof DefaultMutableTreeNode)
       {
         DefaultMutableTreeNode node =
                 (DefaultMutableTreeNode) last;
         Object obj = node.getUserObject ();
         if (obj instanceof FileInfo)
         {
            FileInfo fi = (FileInfo) obj;
            File f = fi.getFile();
            showFiles (f);
         }
       }
    }//GEN-LAST:event_jTree1ValueChanged

    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        int inx = jList1.getSelectedIndex();
        if (visibleDir != null && inx >= 0)
        {
            File [] list = visibleDir.listFiles ();
            if (inx <= list.length)
               showOneFile (list [inx]);
        }
    }//GEN-LAST:event_jList1ValueChanged

    private void showOneFile(File file)
    {
        jTextArea1.setText ("");
        String fileName = file.getAbsolutePath();

        try 
        {
           // import javax.swing.*;
           // import java.awt.*;
           // import javax.imageio.*;

           Image img = ImageIO.read (file);
           Icon icon = new ImageIcon (img);
           jLabel1.setIcon(icon);
        }
        catch (IOException ex)
        {
            jTextArea1.setText (ex.getMessage());
        }
           
        try
        {
            FileInputStream fis =
                  new FileInputStream (fileName);
            
            BufferedInputStream bis =
                  new BufferedInputStream (fis);
            
            DataInputStream dis =
                  new DataInputStream(bis);

            while (dis.available() != 0)
            {
               String txt = dis.readLine();
               jTextArea1.append (txt + "\n");
            }

        }
        catch (FileNotFoundException ex)
        {
            jTextArea1.setText (ex.getMessage());
        }
        catch (IOException ex)
        {
            jTextArea1.setText (ex.getMessage());
        }
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables

}
